/*******************************************************************************
 * Copyright (c) 2011, Daniel Murphy
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without modification,
 * are permitted provided that the following conditions are met:
 * 	* Redistributions of source code must retain the above copyright notice,
 * 	  this list of conditions and the following disclaimer.
 * 	* Redistributions in binary form must reproduce the above copyright notice,
 * 	  this list of conditions and the following disclaimer in the documentation
 * 	  and/or other materials provided with the distribution.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
 * WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
 * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
 * PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 ******************************************************************************/
package org.jbox2d.dynamics.contacts;

import org.jbox2d.common.Vec2;

// updated to rev 100 - ec

public class ContactConstraintPoint {
	
    public final Vec2 localPoint;
    public final Vec2 rA;
    public final Vec2 rB;

    public float normalImpulse;
    public float tangentImpulse;
    public float normalMass;
    public float tangentMass;
    public float velocityBias;

    public ContactConstraintPoint() {
        localPoint = new Vec2();
        rA = new Vec2();
        rB = new Vec2();
    }
    
    public void set(final ContactConstraintPoint cp){
    	localPoint.set(cp.localPoint);
    	rA.set(cp.rA);
    	rB.set(cp.rB);
    	normalImpulse = cp.normalImpulse;
    	tangentImpulse = cp.tangentImpulse;
    	normalMass = cp.normalMass;
    	tangentMass = cp.tangentMass;
        velocityBias = cp.velocityBias;
    }
}
